clear all;
clc;
%==========================================================================
% computes the transition prob matrix and level of agg shocks
%==========================================================================
%==========================================================================
% aggregate transition probability matrix
% [ q_s   1-q_s
% [1-p_s   p_s]
%==========================================================================
% M1 to M4
M(1:4) = [0 2.65 0.0183 0.018];


x0 = [0.5 0.5];
% Calibration for aggregate transization matrix
[x Val1]= fsolve(@calibration_Ztrans,x0,[],M);
p_s = x(1);
q_s = x(2);

% The aggregate transition matrix
Ztrans = [q_s 1-q_s
          1-p_s p_s];
b  =  (1-q_s)/(2-q_s-p_s);
a  =  1-b;

% the invariant distributiom
Inv_Ztrans = [a b];

% Calibration for aggregate shocks
x0 = [0.95 1.05]; 
[x Val2]= fsolve(@calibration_Zshocks,x0,[],Inv_Ztrans,M);

% level of aggregate shocks
Zshocks = x;
