%==========================================================================
% This program compuite the wealth dist and portfolio dist
%==========================================================================
clear all;
clc
load environ_cal_9
Z_STATE   = uint16(Z_STATE);
load H_all
load functions

%==========================================================================
% Modified the Eshocks for each group
%==========================================================================
Ztrans_total = repmat(Ztrans(ZlagRe1st,:),Enum,Enum);
index = [ZlagRe1st ;ZlagRe1st+Znum];
Etrans_total = EZtrans(index,:);

for case_ind = 1:size(MM,2)
    case_ind
    omega1 = MM(1,case_ind);
    omega2 = MM(2,case_ind);
    omega3 = MM(3,case_ind);
    omega4 = MM(4,case_ind);
    omega5 = MM(5,case_ind);
    H = H_all{1,case_ind}
    Sav_com   = Sav_functions{1,case_ind};
    Sav_z    = Sav_functions{2,case_ind};
    Sav_cap  = Sav_functions{3,case_ind};
    Sav_bond = Sav_functions{4,case_ind};
    Sav_pr_b = Sav_functions{5,case_ind};
    Sav_pr_nb= Sav_functions{6,case_ind};
    Cpr_com  = Cpr_functions{1,case_ind};
    Cpr_z    = Cpr_functions{2,case_ind};
    Cpr_cap  = Cpr_functions{3,case_ind};
    Cpr_bond = Cpr_functions{4,case_ind};
    Cpr_b    = Cpr_functions{5,case_ind};
    Cpr_nb   = Cpr_functions{6,case_ind};

%==========================================================================
% Asset Prices
%==========================================================================
    R_z_final = beta*repmat(Zshocks'.^-gama,ZtotalRe,1).*Ztrans(ZlagRe1st,:).*H.^gama;
    risk_free = sum(R_z_final,2).^(-1);
    
    % P/d ratio for aggregate consumption
    ac_temp = sum(R_z_final.*repmat(Zshocks',ZtotalRe,1),2);
    zshocks_tmp = zeros(ZtotalRe,ZtotalRe);
       for i = 1:ZtotalRe
         zshocks_tmp(i,ZINDRe(i,:)) = R_z_final(i,:).*Zshocks';
       end  
    ac_pd = inv(eye(ZtotalRe)-zshocks_tmp)*ac_temp;
    Return_LCS  = (((ac_pd(ZINDRe) + 1).*repmat(Zshocks',ZtotalRe,1)./repmat(ac_pd,1,Znum)...
            -L*repmat(risk_free,1,Znum))/(1-L))./repmat(Zshocks',ZtotalRe,1);
    Return_RFS  = repmat(risk_free,1,Znum)./repmat(Zshocks',ZtotalRe,1);
    risk_free_total  = repmat(risk_free,Enum,1);
    Return_matrix = repmat([Return_LCS.*repmat(Zshocks',ZtotalRe,1) Return_RFS.*repmat(Zshocks',ZtotalRe,1)],Enum,1);
        pos{1}        = (1:ZtotalRe*Enum)'; 
    pos{2}        = EZINDRe; 
    
    % K period return and H
    for k=2:K
    for i=1:ZtotalRe*Enum
        pos{k+1}(i,:) = reshape(EZINDRe(pos{k}(i,:),:)',1,(Enum*Znum)^k);
    end
    end

%==========================================================================
% Simulation Data Panel
%==========================================================================
tic
disp('simulation panel')
  C_STATE =repmat(single(1),N-1,T);
  H_STATE =repmat(single(1),size(T_STATERe));
  cpr     =repmat(single(1),N-1,1);  
  h_update = repmat(single(1),T,1);
  N1 = round((N-1)*omega1);
  N2 = round((N-1)*(omega2+omega1));
  N3 = round((N-1)*(omega3+omega2+omega1));
  N4 = round((N-1)*(omega4+omega3+omega2+omega1));
  C_STATE_N5 = repmat(single(1),N-1-N4,K);
  C_STATE_TMP = repmat(single(1),N-1,2);
  cpr_tmpsim = cell(K,K+1);
  for kk=1:K
      for k=1:K+1
      cpr_tmpsim{kk,k} = ones(N-1-N4,1);
      end
  end

  for t=1:T-K
      pick = [(E_STATE(:,t)==1).*(E_STATE(:,t+1)==1) (E_STATE(:,t)==1).*(E_STATE(:,t+1)==2)...
             (E_STATE(:,t)==2).*(E_STATE(:,t+1)==1) (E_STATE(:,t)==2).*(E_STATE(:,t+1)==2)];         
      Agg_pick =  [Z_STATE(1,t+1) Z_STATE(1,t+1)+Znum];
      if omega1~=0      
         cp_tmp       = [Cpr_com{T_STATERe(1,t)}(:,Agg_pick) Cpr_com{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick)];
         cpr(1:N1)    = sum(interp1(mgrid2,cp_tmp,C_STATE(1:N1,t),'linear','extrap').*pick(1:N1,:),2);
      end
      
      if omega2~=0
         cp_tmp     = [Cpr_z{T_STATERe(1,t)}(:,Agg_pick) Cpr_z{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick)];
         cpr(N1+1:N2)  = sum(interp1(mgrid2,cp_tmp,C_STATE(N1+1:N2,t),'linear','extrap').*pick(N1+1:N2,:),2);
      end
      
      if omega3~=0
         cp_tmp     = [Cpr_cap{T_STATERe(1,t)}(:,Agg_pick) Cpr_cap{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick)];
         cpr(N2+1:N3)   = sum(interp1(mgrid2,cp_tmp,C_STATE(N2+1:N3,t),'linear','extrap').*pick(N2+1:N3,:),2);
      end
      
      if omega4~=0
         cp_tmp     = [Cpr_bond{T_STATERe(1,t)}(:,Agg_pick) Cpr_bond{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick)];
         cpr(N3+1:N4)   = sum(interp1(mgrid2,cp_tmp,C_STATE(N3+1:N4,t),'linear','extrap').*pick(N3+1:N4,:),2);
      end      
      if omega5~=0
          kk = rem(t-1,K)+1;
          if t>K
          C_STATE_N5(:,kk) = C_STATE_N5(:,kk)/h_update(t-1);
          end
             Agg_pick2{1} = Agg_pick;
             pick2{1}     = pick;
            for k=2:K
                Agg_pick2{k} = kron(double(Agg_pick2{k-1}-1)*(Enum*Znum),ones(1,Enum)) + double(repmat([Z_STATE(1,t+k) Z_STATE(1,t+k)+Znum],1,Enum^(k-1)));
                for ii=1:size(pick2{k-1},2)
                pick2{k}(:,[(ii-1)*Enum + [1 2]]) = repmat(pick2{k-1}(:,ii),1,Enum).*[(E_STATE(:,t+k)==1) (E_STATE(:,t+k)==2)];
                end
                cp_tmptmp{k} = [Cpr_nb{k,T_STATERe(1,t)}(:,Agg_pick2{k-1}) Cpr_nb{k,T_STATERe(1,t)+ZtotalRe}(:,Agg_pick2{k-1})];
                cpr_tmpsim{kk,k}   = sum(interp1(mgrid2,cp_tmptmp{k},C_STATE_N5(:,kk),'linear','extrap').*pick2{k-1}(N4+1:N-1,:),2);
            end
                
            cp_tmptmp{K+1} = [Cpr_b{T_STATERe(1,t)}(:,Agg_pick2{k}) Cpr_b{T_STATERe(1,t)+ZtotalRe}(:,Agg_pick2{k})];
            cpr_tmpsim{kk,K+1}   = sum(interp1(mgrid2,cp_tmptmp{K+1},C_STATE_N5(:,kk),'linear','extrap').*pick2{k}(N4+1:N-1,:),2);
            C_STATE_N5(:,kk) = cpr_tmpsim{kk,K+1};
            for kkk=1:K
            cpr_tmpN5(:,kkk) = cpr_tmpsim{kkk,Choose(kkk,kk)};
            end            
            cpr(N4+1:N-1) = sum(cpr_tmpN5.*kron(eye(K),ones((N-1-N4)/K,1)),2);
      end      
      cpr = min(cpr,1.5*Mmax);
      h_update(t) = mean(cpr);
      C_STATE(:,t+1) = cpr/h_update(t);
      H_STATE(1,t+1) = h_update(t)*H(T_STATERe(1,t),Z_STATE(1,t+1)); 
  end
toc

%==========================================================================
tt = T-K;
tt_i = 5000; % Number of period to simulate
%==========================================================================
% Return Simulation
%==========================================================================
  for t=tt-tt_i:tt
      jj = t-tt+tt_i+1;
      EReturn_LC_sim(1,jj) = Return_LCS(T_STATERe(t-1),Z_STATE(t));
  end
  
%==========================================================================
W_STATE = repmat(single(0),N4,tt_i+1);
Port_STATE = repmat(single(0),N4,tt_i+1);

WReturn_com = [];
port_ch_com =[];
Wmean_com   = repmat(zeros(1,1),1,tt_i+1);
Portmean_com = repmat(zeros(1,1),1,tt_i+1);
PortShare_mean_com = 0;
if omega1~=0
  NetSav_com = max(-Sav_com - repmat(mgrid2,1,ZtotalRe*Enum) + repmat(Income_total(:,1)',dimgrid2,1),0.01);
  Sav_com_tmp = max(-Sav_com,0);
  for i=1:ZtotalRe*Enum;
      Etrans_tmp = Etrans_total(i,:);
      for j=1:Enum*Znum
       Sav_pr(:,j) = interp1(mgrid2,Sav_com_tmp(:,EZINDRe(i,j)),Cpr_com{i}(:,j),'linear','extrap');
      end
      WReturn_com{i} = (Sav_pr./repmat(NetSav_com(:,i),1,Enum*Znum)).*...
          repmat(Zshocks',dimgrid2,2).*repmat(Etrans_tmp,dimgrid2,1)*([eye(Enum);eye(Enum)]);
      port_ch_com{i} = (inv(reshape(Return_matrix(i,:),Znum,Znum))*WReturn_com{i}')';

  end
  for t=tt-tt_i:tt
      jj = t-tt+tt_i+1;
      W_STATE(1:N1,jj) = max(interp1(mgrid2,-Sav_com(:,T_STATERe(t)),C_STATE(1:N1,t),'linear','extrap').*(E_STATE(1:N1,t)==1)+...
                      interp1(mgrid2,-Sav_com(:,T_STATERe(t)+ZtotalRe),C_STATE(1:N1,t),'linear','extrap').*(E_STATE(1:N1,t)==2),0);           
      Port_STATE(1:N1,jj) = ([interp1(mgrid2,port_ch_com{T_STATERe(t)}(:,1),C_STATE(1:N1,t)).*(E_STATE(1:N1,t)==1)+...
                             interp1(mgrid2,port_ch_com{T_STATERe(t)+ZtotalRe}(:,1),C_STATE(1:N1,t)).*(E_STATE(1:N1,t)==2)]);
  end
     Wmean_com = mean(W_STATE(1:N1,:)); 
     Portmean_com = mean(W_STATE(1:N1,:).*Port_STATE(1:N1,:));
     PortShare_mean_com = mean(mean(Port_STATE(1:N1,:)));
end
     

WReturn_z =[];
port_ch_z =[];
Wmean_z   = repmat(zeros(1,1),1,tt_i+1);
Portmean_z = repmat(zeros(1,1),1,tt_i+1);
PortShare_mean_z = 0;
if omega2~=0
  NetSav_z = max(-Sav_z - repmat(mgrid2,1,ZtotalRe*Enum) + repmat(Income_total(:,2)',dimgrid2,1),0.01);
  Sav_z_tmp = max(-Sav_z,0);
  for i=1:ZtotalRe*Enum;
      Etrans_tmp = Etrans_total(i,:);
      for j=1:Enum*Znum
       Sav_pr(:,j) = interp1(mgrid2,Sav_z_tmp(:,EZINDRe(i,j)),Cpr_z{i}(:,j),'linear','extrap');
      end
      WReturn_z{i} = (Sav_pr./repmat(NetSav_z(:,i),1,Enum*Znum)).*...
          repmat(Zshocks',dimgrid2,2).*repmat(Etrans_tmp,dimgrid2,1)*([eye(Enum);eye(Enum)]);
      port_ch_z{i} = (inv(reshape(Return_matrix(i,:),Znum,Znum))*WReturn_z{i}')';
  end
  for t=tt-tt_i:tt
      jj = t-tt+tt_i+1;
      W_STATE(N1+1:N2,jj)   = max(interp1(mgrid2,-Sav_z(:,T_STATERe(t)),C_STATE(N1+1:N2,t),'linear','extrap').*(E_STATE(N1+1:N2,t)==1)+...
                           interp1(mgrid2,-Sav_z(:,T_STATERe(t)+ZtotalRe),C_STATE(N1+1:N2,t),'linear','extrap').*(E_STATE(N1+1:N2,t)==2),0);                       
      Port_STATE(N1+1:N2,jj) = ([interp1(mgrid2,port_ch_z{T_STATERe(t)}(:,1),C_STATE(N1+1:N2,t),'linear','extrap').*(E_STATE(N1+1:N2,t)==1)+...
         interp1(mgrid2,port_ch_z{T_STATERe(t)+ZtotalRe}(:,1),C_STATE(N1+1:N2,t),'linear','extrap').*(E_STATE(N1+1:N2,t)==2)]);
  end
      Wmean_z = mean(W_STATE(N1+1:N2,:));
      Portmean_z = mean(W_STATE(N1+1:N2,:).*Port_STATE(N1+1:N2,:));
      PortShare_mean_z = mean(mean(Port_STATE(N1+1:N2,:)));
end

Wmean_cap   = repmat(zeros(1,1),1,tt_i+1);
Portmean_cap = repmat(zeros(1,1),1,tt_i+1);
if omega3~=0                
  for t=tt-tt_i:tt
      jj = t-tt+tt_i+1;
        W_STATE(N2+1:N3,jj) = max(interp1(mgrid2,-Sav_cap(:,T_STATERe(t)),C_STATE(N2+1:N3,t),'linear','extrap').*(E_STATE(N2+1:N3,t)==1)+...
                           interp1(mgrid2,-Sav_cap(:,T_STATERe(t)+ZtotalRe),C_STATE(N2+1:N3,t),'linear','extrap').*(E_STATE(N2+1:N3,t)==2),0);
    end
    Port_STATE(N2+1:N3,:) = port_share;
    Wmean_cap = mean(W_STATE(N2+1:N3,:));
    Portmean_cap = port_share*Wmean_cap;
end
    PortShare_mean_cap = port_share;

Wmean_bond   = repmat(zeros(1,1),1,tt_i+1);
if omega4~=0 
  for t=tt-tt_i:tt
      jj = t-tt+tt_i+1;      
     W_STATE(N3+1:N4,jj) = max(interp1(mgrid2,-Sav_bond(:,T_STATERe(t)),C_STATE(N3+1:N4,t),'linear','extrap').*(E_STATE(N3+1:N4,t)==1)+...
                           interp1(mgrid2,-Sav_bond(:,T_STATERe(t)+ZtotalRe),C_STATE(N3+1:N4,t),'linear','extrap').*(E_STATE(N3+1:N4,t)==2),0);
   end
   Port_STATE(N3+1:N4,:) = 0;
   Wmean_bond = mean(W_STATE(N3+1:N4,:));
end
   PortShare_mean_bond = 0;

AWH_prb_tmp = [];
port_sim_prb = [];
Wmean_prb  = repmat(zeros(1,1),1,tt_i+1);
Portmean_prb = repmat(zeros(1,1),1,tt_i+1);
if omega5~=0
      % Compute the wealth dist for prb  
      % first K-1 periods before jj
      AWH_prb_tmp = repmat(single(0),N-1-N4,tt_i+1);
      port_sim_prb = repmat(single(0),N-1-N4,tt_i+1);
      for kkkk=1:K-1
         jj=tt-tt_i-K+kkkk;
         kk = rem(jj-1,K)+1;
         AWH_prb_tmp2{kk,1} = max((-[interp1(mgrid2,Sav_pr_b(:,T_STATERe(jj)),C_STATE(N4+1:N-1,jj)).*(E_STATE(N4+1:N-1,jj)==1)+...
                                interp1(mgrid2,Sav_pr_b(:,T_STATERe(jj)+ZtotalRe),C_STATE(N4+1:N-1,jj)).*(E_STATE(N4+1:N-1,jj)==2)]),0);
         Port_prb_tmp2{kk,1} = port_share*ones(N-1-N4,1);
         for k=2:K
                Agg_pick2{k} = kron(double(Agg_pick2{k-1}-1)*(Enum*Znum),ones(1,Enum)) + double(repmat([Z_STATE(1,t+k) Z_STATE(1,t+k)+Znum],1,Enum^(k-1)));
                for ii=1:size(pick2{k-1},2)
                pick2{k}(:,[(ii-1)*Enum + [1 2]]) = repmat(pick2{k-1}(:,ii),1,Enum).*[(E_STATE(:,t+k)==1) (E_STATE(:,t+k)==2)];
                end        
                AWH_prb_tmp3  = AWH_prb_tmp2{kk,k-1}-C_STATE(N4+1:N-1,jj+k-2)+...
                        Eshocks_total(repmat(uint8(Z_STATE(jj+k-2)),N-1-N4,1)+2*(E_STATE(N4+1:N-1,jj+k-2)-1),1);           
                AWH_prb_tmp2{kk,k} = sum(max((-[interp1(mgrid2,Sav_pr_nb{k,T_STATERe(jj)}(:,Agg_pick2{k-1}),C_STATE(N4+1:N-1,jj+k-1))...
                                       interp1(mgrid2,Sav_pr_nb{k,T_STATERe(jj)+ZtotalRe}(:,Agg_pick2{k-1}),C_STATE(N4+1:N-1,jj+k-1))]),0.01).*pick2{k-1}(N4+1:N-1,:),2)...
                                       + AWH_prb_tmp3*port_share*Return_LCS(T_STATERe(jj+k-2),Z_STATE(jj+k-1));
                Port_prb_tmp2{kk,k} = AWH_prb_tmp3*port_share*Return_LCS(T_STATERe(jj+k-2),Z_STATE(jj+k-1))./AWH_prb_tmp2{kk,k}; 
         end                   
      end
      % jj starts here          
         for jj=tt-tt_i:tt
         kk = rem(jj-1,K)+1;
         Agg_pick2{1} = [Z_STATE(1,jj+1) Z_STATE(1,jj+1)+Znum];
         pick2{1}     = [(E_STATE(:,jj)==1).*(E_STATE(:,jj+1)==1) (E_STATE(:,jj)==1).*(E_STATE(:,jj+1)==2)...
                         (E_STATE(:,jj)==2).*(E_STATE(:,jj+1)==1) (E_STATE(:,jj)==2).*(E_STATE(:,jj+1)==2)];
         AWH_prb_tmp2{kk,1} = max((-[interp1(mgrid2,Sav_pr_b(:,T_STATERe(jj)),C_STATE(N4+1:N-1,jj)).*(E_STATE(N4+1:N-1,jj)==1)+...
                                interp1(mgrid2,Sav_pr_b(:,T_STATERe(jj)+ZtotalRe),C_STATE(N4+1:N-1,jj)).*(E_STATE(N4+1:N-1,jj)==2)]),0.01);
         Port_prb_tmp2{kk,1} = port_share*ones(N-1-N4,1);
           for k=2:K
                Agg_pick2{k} = kron(double(Agg_pick2{k-1}-1)*(Enum*Znum),ones(1,Enum)) + double(repmat([Z_STATE(1,t+k) Z_STATE(1,t+k)+Znum],1,Enum^(k-1)));
                for ii=1:size(pick2{k-1},2)
                pick2{k}(:,[(ii-1)*Enum + [1 2]]) = repmat(pick2{k-1}(:,ii),1,Enum).*[(E_STATE(:,t+k)==1) (E_STATE(:,t+k)==2)];
                end      
                AWH_prb_tmp3  = AWH_prb_tmp2{kk,k-1}-C_STATE(N4+1:N-1,jj+k-2)+...
                        Eshocks_total(repmat(uint8(Z_STATE(jj+k-2)),N-1-N4,1)+2*(E_STATE(N4+1:N-1,jj+k-2)-1),1);           
                AWH_prb_tmp2{kk,k} = sum(max((-[interp1(mgrid2,Sav_pr_nb{k,T_STATERe(jj)}(:,Agg_pick2{k-1}),C_STATE(N4+1:N-1,jj+k-1))...
                                       interp1(mgrid2,Sav_pr_nb{k,T_STATERe(jj)+ZtotalRe}(:,Agg_pick2{k-1}),C_STATE(N4+1:N-1,jj+k-1))]),0.01).*pick2{k-1}(N4+1:N-1,:),2)...
                                       + AWH_prb_tmp3*port_share*Return_LCS(T_STATERe(jj+k-2),Z_STATE(jj+k-1));                                   
                Port_prb_tmp2{kk,k} = AWH_prb_tmp3*port_share*Return_LCS(T_STATERe(jj+k-2),Z_STATE(jj+k-1))./AWH_prb_tmp2{kk,k};                             
           end

           for kkk=1:K
            AWH_prb_tmp1(:,kkk) = AWH_prb_tmp2{kkk,Choose(kkk,kk)-1};
            Port_prb_tmp1(:,kkk) = Port_prb_tmp2{kkk,Choose(kkk,kk)-1};
           end
            AWH_prb_tmp(:,jj-tt+tt_i+1) = sum(AWH_prb_tmp1.*kron(eye(K),ones((N-1-N4)/K,1)),2);
            port_sim_prb(:,jj-tt+tt_i+1) = sum(Port_prb_tmp1.*kron(eye(K),ones((N-1-N4)/K,1)),2);
         end
         Wmean_prb    = mean(AWH_prb_tmp);
         Portmean_prb = mean(AWH_prb_tmp.*port_sim_prb);
end
         PortShare_mean_prb = mean(mean(port_sim_prb));

      
      W_STATE_SIM = [W_STATE ; AWH_prb_tmp];
      clear W_STATE C_STATE 
      Port_STATE_SIM = [Port_STATE ; port_sim_prb];
      clear Port_STATE    
      AvgW_all(1,case_ind) = mean(mean(W_STATE_SIM));
%==========================================================================
% Wealth dist statistics
%==========================================================================
 MeanW_all(:,case_ind)  = mean(mean(W_STATE_SIM));
 StdW_all(:,case_ind)   = std(mean(W_STATE_SIM));
      
 MeanRW_all(:,case_ind) = [mean(Wmean_com./mean(W_STATE_SIM)) ; 
                           mean(Wmean_z./mean(W_STATE_SIM))   ; 
                           mean(Wmean_cap./mean(W_STATE_SIM)) ;
                           mean(Wmean_bond./mean(W_STATE_SIM));
                           mean(Wmean_prb./mean(W_STATE_SIM))];
      
 StdRW_all(:,case_ind) = [ std(Wmean_com./mean(W_STATE_SIM)) ; 
                           std(Wmean_z./mean(W_STATE_SIM))   ; 
                           std(Wmean_cap./mean(W_STATE_SIM)) ;
                           std(Wmean_bond./mean(W_STATE_SIM));
                           std(Wmean_prb./mean(W_STATE_SIM))];
 Std_WsA_Ws(1,case_ind) = std(((omega1*Wmean_com+omega2*Wmean_z)/(omega1+omega2))./mean(W_STATE_SIM));
 Corr_WsA_RLC(1,case_ind) = corr(((omega1*Wmean_com+omega2*Wmean_z)/(omega1+omega2))',EReturn_LC_sim');
      
 Std_WsP_WsN(1,case_ind) = std(((omega3*Wmean_cap+omega5*Wmean_prb)/(omega3+omega5))./Wmean_bond);
      
 TotalEquity = omega1*Portmean_com + omega2*Portmean_z + omega3*Portmean_cap+ omega5*Portmean_prb;
 PassiveEquity = omega3*Portmean_cap+ omega5*Portmean_prb;
 Std_Portshare_P(1,case_ind) = std(PassiveEquity./TotalEquity);
      
 Corr_WsP_RLC(1,case_ind) = corr((((omega3*Wmean_cap+omega5*Wmean_prb)/(omega3+omega5))./Wmean_bond)',EReturn_LC_sim');
 Corr_PsP_RLC(1,case_ind) = corr((PassiveEquity./TotalEquity)',EReturn_LC_sim');
      
PortShare_mean_all(:,case_ind) = [PortShare_mean_com PortShare_mean_z PortShare_mean_cap PortShare_mean_bond PortShare_mean_prb]'; 

end
  
Wealth_Stat = [ MeanW_all; StdW_all; MeanRW_all; StdRW_all;
                    Std_WsA_Ws ; Corr_WsA_RLC ; Std_WsP_WsN; Std_Portshare_P; 
                    Corr_WsP_RLC; Corr_PsP_RLC];

save Wealth_Stat Wealth_Stat PortShare_mean_all

%==========================================================================
% Making Tables VI
%==========================================================================
% Table IV, Panel III
%==========================================================================
disp('Aggregate Household Wealth Ratio')
latex(double(sum(Wealth_Stat([3:4],:))),'%.3f')
latex(double(sum(Wealth_Stat([5 7],:))),'%.3f')
latex(double((Wealth_Stat(6,:))),'%.3f')

disp('Stdev. of Aggregate Household Wealth Ratio')
latex(double(sum(Wealth_Stat([8:9],:))),'%.3f')
latex(double(sum(Wealth_Stat([10 12],:))),'%.3f')
latex(double((Wealth_Stat(11,:))),'%.3f')

disp('Stdev. of Aggregate Equity Share')
latex(double((Wealth_Stat(16,:))),'%.3f')

disp('Correlation of Aggregate Equity Share')
latex(double((Wealth_Stat(18,:))),'%.3f')
